# LiveVideoWithOpenCV

## Prerequisites

## Build Environment

### Linux (Ubuntu)

* GCC etc. `sudo apt-get install build-essential`
* CMake `sudo apt-get install cmake`
* OpenCV GUI dependencies `sudo apt-get install libgtk2.0-dev pkg-config`

### Mac

* Xcode > 8.0 (App Store)
* CMake (download installer from cmake.org)

### Windows

* Visual Studio 2017 (Community Edition is fine), with C++ support installed
* CMake (download installer from cmake.org)

## OpenCV

Download OpenCV 3.3.0 Sources from <https://opencv.org/releases/>

      unzip opencv-3.3.0.zip
      cd opencv-3.3.0
      mkdir build
      cd build

### Linux/Mac Build

    cmake -DBUILD_SHARED_LIBS=OFF -DBUILD_opencv_apps=ON -DBUILD_EXAMPLES=ON -DBUILD_DOCS=ON ..
    make -j8
    sudo make install install_docs

### Windows Build

    cmake -G "Visual Studio 15 2017 Win64" -DCMAKE_BUILD_TYPE=Release -DBUILD_SHARED_LIBS=OFF -DBUILD_opencv_apps=ON -DBUILD_EXAMPLES=ON -DBUILD_DOCS=ON ..
    cmake --build . --config Release --target clean
    cmake --build . --config Release --target install

NOTE: Since there is no system default location for OpenCV on Windows, move `build/install` to `OpenCV` under the project directory

## DeckLink SDK

* Download Desktop Video SDK 10.11.4 from <https://www.blackmagicdesign.com/developer/product/capture-and-playback> and extract archive under project directory
* If Desktop Video SDK is extracted outside of the project directory, update the -DDECKLINK_SDK_INCLUDE_DIR in the cmake command below.

## DeckLink Hardware

* DeckLink device capable of simultaneous capture and playout e.g. Intensity Pro 4K, DeckLink Extreme 12G, UltraStudio 4K

## Build LiveVideoWithOpenCV

### Linux Build

Refer to BuildLinux.sh script.

    mkdir build
    cd build
    cmake -DDECKLINK_SDK_INCLUDE_DIR=$(pwd)/../Blackmagic\ DeckLink\ SDK\ 10.11.4/Linux/include ..
    cmake --build . --config Release

### Mac Build

Refer to BuildMac.sh script.

    mkdir build
    cd build
    cmake -DDECKLINK_SDK_INCLUDE_DIR=$(pwd)/../Blackmagic\ DeckLink\ SDK\ 10.11.4/Mac/include ..
    cmake --build . --config Release

### Windows Build

Refer to BuildWin.bat batch file.

NOTE: Build mode must match OpenCV build, which was built as _Release_

    set OpenCV_DIR=%cd%\OpenCV
    mkdir build
    cd build
    cmake -G "Visual Studio 15 2017 Win64" -DDECKLINK_SDK_INCLUDE_DIR="%cd%\..\Blackmagic DeckLink SDK 10.11.4\Win\include" -DOpenCV_STATIC=ON -DOpenCV_RUNTIME=vc15 ..
    cmake --build . --config Release

## Running LiveVideoWithOpenCV

Run the LiveVideoWithOpenCV executable and it will begin capturing from the DeckLink input, process the video and output the processed result on the DeckLink output.
